CsiAdaptorProtocol (Apache Hadoop YARN API 3.5.0 API)
Description: declaration: package: org.apache.hadoop.yarn.api, interface: CsiAdaptorProtocol

Package org.apache.hadoop.yarn.api

# Interface CsiAdaptorProtocol

All Known Subinterfaces:
  `CsiAdaptorPlugin`

public interface CsiAdaptorProtocol
CSI adaptor delegates all the calls from YARN to a CSI driver.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `GetPluginInfoResponse`
  `getPluginInfo(GetPluginInfoRequest request)`
  Get plugin info from the CSI driver.
  `NodePublishVolumeResponse`
  `nodePublishVolume(NodePublishVolumeRequest request)`
  Publish the volume on a node manager, the volume will be mounted to the local file system and become visible for clients.
  `NodeUnpublishVolumeResponse`
  `nodeUnpublishVolume(NodeUnpublishVolumeRequest request)`
  This is a reverse operation of `nodePublishVolume(NodePublishVolumeRequest)`, it un-mounts the volume from given node.
  `ValidateVolumeCapabilitiesResponse`
  `validateVolumeCapacity(ValidateVolumeCapabilitiesRequest request)`
  Validate if the volume capacity can be satisfied on the underneath storage system.

- ## Method Details

  - ### getPluginInfo

    GetPluginInfoResponse getPluginInfo(GetPluginInfoRequest request) throws YarnException, IOException
    Get plugin info from the CSI driver. The driver usually returns the name of the driver and its version.
    Parameters:
      `request` - get plugin info request.
    Returns:
      response that contains driver name and its version.
    Throws:
      `YarnException` - exceptions from yarn servers.
      `IOException` - io error occur.

  - ### validateVolumeCapacity

    ValidateVolumeCapabilitiesResponse validateVolumeCapacity(ValidateVolumeCapabilitiesRequest request) throws YarnException, IOException
    Validate if the volume capacity can be satisfied on the underneath storage system. This method responses if the capacity can be satisfied or not, with a detailed message.
    Parameters:
      `request` - validate volume capability request.
    Returns:
      validation response.
    Throws:
      `YarnException` - exceptions from yarn servers.
      `IOException` - io error occur.

  - ### nodePublishVolume

    NodePublishVolumeResponse nodePublishVolume(NodePublishVolumeRequest request) throws YarnException, IOException
    Publish the volume on a node manager, the volume will be mounted to the local file system and become visible for clients.
    Parameters:
      `request` - publish volume request.
    Returns:
      publish volume response.
    Throws:
      `YarnException` - exceptions from yarn servers.
      `IOException` - io error occur.

  - ### nodeUnpublishVolume

    NodeUnpublishVolumeResponse nodeUnpublishVolume(NodeUnpublishVolumeRequest request) throws YarnException, IOException
    This is a reverse operation of `nodePublishVolume(NodePublishVolumeRequest)`, it un-mounts the volume from given node.
    Parameters:
      `request` - un-publish volume request.
    Returns:
      un-publish volume response.
    Throws:
      `YarnException` - exceptions from yarn servers.
      `IOException` - io error occur.